# Class VulkanImageSubresourceLayers.Builder

java.lang.Object
com.io7m.jcoronado.api.VulkanImageSubresourceLayers.Builder

Enclosing class:
  `VulkanImageSubresourceLayers`

public static final class VulkanImageSubresourceLayers.Builder extends Object
Builds instances of type `VulkanImageSubresourceLayers`. Initialize attributes and then invoke the `build()` method to create an immutable instance.

`Builder` is not thread-safe and generally should not be stored in a field or collection, but instead used immediately to create instances.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `final VulkanImageSubresourceLayers.Builder`
  `addAllAspectMask(Iterable<VulkanImageAspectFlag> elements)`
  Adds elements to `aspectMask` set.
  `final VulkanImageSubresourceLayers.Builder`
  `addAspectMask(VulkanImageAspectFlag element)`
  Adds one element to `aspectMask` set.
  `final VulkanImageSubresourceLayers.Builder`
  `addAspectMask(VulkanImageAspectFlag... elements)`
  Adds elements to `aspectMask` set.
  `VulkanImageSubresourceLayers`
  `build()`
  Builds a new `VulkanImageSubresourceLayers`.
  `final VulkanImageSubresourceLayers.Builder`
  `from(VulkanImageSubresourceLayersType instance)`
  Fill a builder with attribute values from the provided `VulkanImageSubresourceLayersType` instance.
  `final VulkanImageSubresourceLayers.Builder`
  `setAspectMask(Iterable<VulkanImageAspectFlag> elements)`
  Sets or replaces all elements for `aspectMask` set.
  `final VulkanImageSubresourceLayers.Builder`
  `setBaseArrayLayer(int baseArrayLayer)`
  Initializes the value for the `baseArrayLayer` attribute.
  `final VulkanImageSubresourceLayers.Builder`
  `setLayerCount(int layerCount)`
  Initializes the value for the `layerCount` attribute.
  `final VulkanImageSubresourceLayers.Builder`
  `setMipLevel(int mipLevel)`
  Initializes the value for the `mipLevel` attribute.

  ### Methods inherited from class Object

  `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- ## Method Details

  - ### from

    public final VulkanImageSubresourceLayers.Builder from(VulkanImageSubresourceLayersType instance)
    Fill a builder with attribute values from the provided `VulkanImageSubresourceLayersType` instance. Regular attribute values will be replaced with those from the given instance. Absent optional values will not replace present values. Collection elements and entries will be added, not replaced.
    Parameters:
      `instance` - The instance from which to copy values
    Returns:
      `this` builder for use in a chained invocation

  - ### addAspectMask

    public final VulkanImageSubresourceLayers.Builder addAspectMask(VulkanImageAspectFlag element)
    Adds one element to `aspectMask` set.
    Parameters:
      `element` - A aspectMask element
    Returns:
      `this` builder for use in a chained invocation

  - ### addAspectMask

    public final VulkanImageSubresourceLayers.Builder addAspectMask(VulkanImageAspectFlag... elements)
    Adds elements to `aspectMask` set.
    Parameters:
      `elements` - An array of aspectMask elements
    Returns:
      `this` builder for use in a chained invocation

  - ### setAspectMask

    public final VulkanImageSubresourceLayers.Builder setAspectMask(Iterable<VulkanImageAspectFlag> elements)
    Sets or replaces all elements for `aspectMask` set.
    Parameters:
      `elements` - An iterable of aspectMask elements
    Returns:
      `this` builder for use in a chained invocation

  - ### addAllAspectMask

    public final VulkanImageSubresourceLayers.Builder addAllAspectMask(Iterable<VulkanImageAspectFlag> elements)
    Adds elements to `aspectMask` set.
    Parameters:
      `elements` - An iterable of aspectMask elements
    Returns:
      `this` builder for use in a chained invocation

  - ### setMipLevel

    public final VulkanImageSubresourceLayers.Builder setMipLevel(int mipLevel)
    Initializes the value for the `mipLevel` attribute.

    If not set, this attribute will have a default value as returned by the initializer of `mipLevel`.

    Parameters:
      `mipLevel` - The value for mipLevel
    Returns:
      `this` builder for use in a chained invocation

  - ### setBaseArrayLayer

    public final VulkanImageSubresourceLayers.Builder setBaseArrayLayer(int baseArrayLayer)
    Initializes the value for the `baseArrayLayer` attribute.

    If not set, this attribute will have a default value as returned by the initializer of `baseArrayLayer`.

    Parameters:
      `baseArrayLayer` - The value for baseArrayLayer
    Returns:
      `this` builder for use in a chained invocation

  - ### setLayerCount

    public final VulkanImageSubresourceLayers.Builder setLayerCount(int layerCount)
    Initializes the value for the `layerCount` attribute.

    If not set, this attribute will have a default value as returned by the initializer of `layerCount`.

    Parameters:
      `layerCount` - The value for layerCount
    Returns:
      `this` builder for use in a chained invocation

  - ### build

    public VulkanImageSubresourceLayers build()
    Builds a new `VulkanImageSubresourceLayers`.
    Returns:
      An immutable instance of VulkanImageSubresourceLayers
    Throws:
      `IllegalStateException` - if any required attributes are missing